package GUI;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class EjEventos extends WindowAdapter implements ActionListener, ItemListener {

    private Frame frame;
    private Choice menuColores;
    private String[] colores = {"Black", "Red", "Blue", "Green", "White"};
    private SketchCanvas hoja;
    private Panel panelBotones,  panelArchivo;
    private Button botonBorrar,  botonGuardar;
    private Label etiquetaArchivo;
    private TextField nombreArchivo;

    public EjEventos() {
        frame = new Frame("Ejercicio Manejo Eventos");
        menuColores = new Choice();
        hoja = new SketchCanvas();
        panelBotones = new Panel();
        botonBorrar = new Button("Borrar");
        botonGuardar = new Button("Guardar");
        panelArchivo = new Panel();
        etiquetaArchivo = new Label("Archivo");
        nombreArchivo = new TextField();
    }

    public void run() {
        for (int i = 0; i < colores.length; i++) {
            menuColores.addItem(colores[i]);
        }
        hoja.setBackground(Color.white);
        panelBotones.setLayout(new GridLayout(2, 1));
        panelBotones.add(botonGuardar);
        panelBotones.add(botonBorrar);
        panelArchivo.setLayout(new GridLayout(1, 2));
        panelArchivo.add(etiquetaArchivo);
        panelArchivo.add(nombreArchivo);
        frame.add(menuColores, BorderLayout.NORTH);
        frame.add(hoja, BorderLayout.CENTER);
        frame.add(panelBotones, BorderLayout.WEST);
        frame.add(panelArchivo, BorderLayout.SOUTH);

        menuColores.addItemListener(this);
        botonGuardar.addActionListener(this);
        botonBorrar.addActionListener(this);
        frame.addWindowListener(this);

        frame.pack();
        frame.setVisible(true);
    }

    public static void main(String[] args) {
        EjEventos demo = new EjEventos();
        demo.run();
    }

    public void actionPerformed(ActionEvent evento) {
        Button botonActivo = (Button) evento.getSource();
        if (botonActivo.equals(botonGuardar)) {
            System.out.println("No sabemos como guardar!!!");
        } else {
            hoja.borrar();
        }
    }

    @Override
    public void windowClosing(WindowEvent evento) {
        System.exit(0);
    }

    public void itemStateChanged(ItemEvent evento) {
        String color = (String) evento.getItem();
        if (color.equals("Black")) {
            hoja.setForeground(Color.black);
        } else if (color.equals("Red")) {
            hoja.setForeground(Color.red);
        } else if (color.equals("Blue")) {
            hoja.setForeground(Color.blue);
        } else if (color.equals("Green")) {
            hoja.setForeground(Color.green);
        } else if (color.equals("White")) {
            hoja.setForeground(Color.white);
        }
    }

    public class SketchCanvas extends Canvas
            implements MouseListener, MouseMotionListener {

        private Vector theVector;
        private int startX;
        private int startY;

        public SketchCanvas() {
            theVector = new Vector();
            setSize(500, 500);
            addMouseMotionListener(this);
            addMouseListener(this);
        }

        private void drawLine(Graphics graphics, int[] points) {
            graphics.drawLine(points[0], points[1],
                    points[2], points[3]);
        }

        public void borrar() {
            Graphics graphics = getGraphics();
            Dimension dimension = getSize();
            int height = (int) dimension.getHeight();
            int width = (int) dimension.getWidth();
            graphics.clearRect(0, 0, width, height);
            theVector.clear();
        }

        @Override
        public void paint(Graphics graphics) {
            Iterator iterator = theVector.iterator();
            while (iterator.hasNext()) {
                int[] points = (int[]) iterator.next();
                drawLine(graphics, points);
            }
        }

        public void mousePressed(MouseEvent evento) {
            startX = evento.getX();
            startY = evento.getY();
        }

        public void mouseDragged(MouseEvent evento) {
            Graphics graphics = getGraphics();
            int endX = evento.getX();
            int endY = evento.getY();
            int[] points = {
                startX, startY, endX, endY
            };
            drawLine(graphics, points);
            theVector.add(points);
            startX = endX;
            startY = endY;
        }

        public void mouseMoved(MouseEvent evento) {
        }

        public void mouseClicked(MouseEvent evento) {
        }

        public void mouseEntered(MouseEvent evento) {
        }

        public void mouseExited(MouseEvent evento) {
        }

        public void mouseReleased(MouseEvent evento) {
        }
    }
}
