package Networking;

import java.io.*;
import java.net.*;

public class DictionaryClient {

    private final static int PORT = 65432;

    public static void main(String[] args) {
        Socket theSocket = null;
        int error = 0;
        try {
            if (args.length < 2) {
                throw new Exception("Usage : java " + "DictionaryClient server " + "word1 word2 ...");
            }
            theSocket = new Socket(args[0], PORT);

            BufferedReader theReceiver = new BufferedReader(
                    new InputStreamReader(theSocket.getInputStream()));
            PrintWriter theTransmitter = new PrintWriter(theSocket.getOutputStream());

            String theResponse = theReceiver.readLine();
            if (!theResponse.equals("HELLO DICTIONARYSERVER")) {
                throw new Exception("Protocol Error.");
            }
            theTransmitter.println("HELLO DICTIONARYCLIENT");
            theTransmitter.flush();
            for (int i = 1; i < args.length; i++) {
                theTransmitter.println(args[i].toUpperCase());
                theTransmitter.flush();

                theResponse = theReceiver.readLine();
                System.out.println(args[i] + " : " + theResponse);
            }

            theTransmitter.println("GOODBYE");
            theTransmitter.flush();
        } catch (Exception theException) {
            System.err.println(theException.getMessage());
            error = 1;
        } finally {
            try {
                theSocket.close();
            } catch (Exception theException) {
            }
            System.exit(error);
        }
    }
}
