package Networking;

import java.io.*;
import java.net.*;
import java.util.*;

public class DictionaryServer {

    private final static int PORT = 65432;

    public static void main(String[] args) {
        Dictionary theDictionary = new Hashtable();
        theDictionary.put("RAM", "Random Access Memory");
        theDictionary.put("TCP", "Transport Control Protocol");
        theDictionary.put("IP", "Internet Protocol");
        theDictionary.put("FTP", "File Transfer Protocol");
        theDictionary.put("ROM", "Read Only Memory");

        try {
            ServerSocket theServerSocket = new ServerSocket(PORT);
            System.out.println("Waiting ...");
            while (true) {
                try {
                    Socket theSocket = theServerSocket.accept();
                    serve(theSocket, theDictionary);
                } catch (Exception theException) {
                    System.out.println(theException.getMessage());
                }
            }
        } catch (IOException io) {
            System.out.println(io.getMessage());
            System.exit(1);
        }
    }

    public static void serve(Socket theSocket, Dictionary theDictionary) {
        try {
            BufferedReader theReceiver = new BufferedReader(
                    new InputStreamReader(theSocket.getInputStream()));
            PrintWriter theTransmitter = new PrintWriter(theSocket.getOutputStream());
            theTransmitter.println("HELLO DICTIONARYSERVER");
            theTransmitter.flush();
            String theRequest = theReceiver.readLine();
            if (!theRequest.equals("HELLO DICTIONARYCLIENT")) {
                throw new Exception("Protocol Error.");
            }
            InetAddress theAddress = theSocket.getInetAddress();
            String theClient = theAddress.getHostAddress();
            theRequest = theReceiver.readLine();
            while (!theRequest.equals("GOODBYE")) {
                String theResponse = (String) theDictionary.get(theRequest);
                if (theResponse == null) {
                    theResponse = "Not Found";
                }
                theTransmitter.println(theResponse);
                theTransmitter.flush();
                System.out.println(theClient + " [" + theRequest + " : " + theResponse + "]");
                theRequest = theReceiver.readLine();
            }
        } catch (Exception theException) {
            System.out.println(theException.getMessage());
        } finally {
            try {
                theSocket.close();
            } catch (IOException io) {
                System.out.println(io.getMessage());
            }
        }
    }
}
